<?php
/** 
* Class to send keys on customer email 
* @package SKOE 
* Version corregida 1 
*	- El correo de processing order verifica stock y depacho automatico, por si 
*     crea una variable _dispatchnow y actualiza el estado a completed
*   - Al cambiar el estado a completed, se activa el correo, el mismo verifica si el metadato
*     _dispatchnow es yes, entonces ejecuta el despacho automatico.
*/
/** 
* CONTIENE DOS HOOKS
* - custom_woocommerce_auto_complete_paid_order	(1 sola funcion)
* - woocommerce_email_customer_details (8 funciones)
* - columna nueva en orders
* 
*/

// Exit if accessed directly 
if( ! defined( 'ABSPATH' ) ) {
    exit;
}



add_action( 'woocommerce_email_customer_details', 'auto_dispatch_table', 5, 4 );

//add_action( 'woocommerce_email_before_order_table', array( $this, 'auto_dispatch_table'), 20, 4 );
//add_action( 'woocommerce_email_after_order_table ', array( $this, 'auto_dispatch_table'), 20, 4 );
/*https://www.businessbloomer.com/woocommerce-add-extra-content-order-email/*/

      
//////////////////////////////////AQUI EMPIEZAN LAS FUNCIONES/////////////////////////////////////////////////

function auto_dispatch_table( $order, $sent_to_admin, $plain_text, $email ) {
        $blog_id = get_current_blog_id();
        switch_to_blog( $blog_id );

        if ( $email->id == 'customer_processing_order' ) {
                //echo " ENTRO POR PROCESING ORDER 1... ";
                global $wpdb;
                $order_id=$order->get_id();
                $despachartodo=TRUE;
                $totalitem=0;
                $items=0;
$depu=array();
                //////////////////
                //bucle de ITEMS de la ORDER
                //////////////////
                foreach( $order->get_items() as $item_id => $item ) {
                        $items++;
                        $product_id_1 = $item->get_product_id();
$depu['product_id_1']=$product_id_1;
                        $autodispatch=get_post_meta($product_id_1,'_autodispatch_option');
                        if($autodispatch[0]<>'yes'){
                                $despachartodo=FALSE;
                        }
$depu['autodispatch']=$autodispatch;
                        $quantity = $item->get_quantity();
$depu['quantity']=$quantity;
                        //las claves son cargadas para el producto raiz, no para las  variaciones
                        //las variaciones solo sirven para descontar el stock
                        $variation_id = $item->get_variation_id();
$depu['variation_id']=$variation_id;
                        if($variation_id==0){
                                $variation_id=$product_id;
                                $variation=1;
                        }else{
                                $variation=obtenervariacion($variation_id);
                        }
$depu['variation']=$variation;
                        if(escombo($product_id_1)){
                                $productoscombo=combos($product_id_1);
                                $l=0;
                        }else{
                                unset($productoscombo);
                                $productoscombo[0]=$product_id_1;
                        }
                        //////////////////
                        //bucle de COMBOS
                        //////////////////
                        foreach($productoscombo as $product){
                                $product_id=$product;
$depu['product'][]=$product;
                                //////////////////
                                //bucle PRODUCT_ID
                                //////////////////
                                $despachados=0;
                                $cuantas=cuantasllaves($product_id,$variation);//Tengo por ejemplo 3 llaves con mas activaciones que variaciones
$depu['cuantas'][]=$cuantas;
                                $totalitem+=$quantity;
                                if($cuantas >= $quantity){ /// SI  TENEMOS MAS LLAVES QUE LA CANTIDAD DEL PEDIDO
                                        //$product_id es el  producto, $variation es 1pc - 5pc, $priority es la prioridad
                                        $priority=1;
                                        $envio1=lasllaves($product_id,$variation,$quantity,$priority);
                                        $envio[] = $envio1;
                                        if($quantity>1){
                                                $despachados+=count($envio1,1);// 1 para recursivo
                                        }else{
                                                $despachados+=count($envio1,1);
                                        }
$depu['despachados'][]=$despachados;
                                }//if cuantas > quantity END
                                if($despachados<>$quantity){
                                        // POR UN PRODUCTO QUE NO TENGA STOCK, SE CANCELA EL DESPACHO AUTOMATICO
                                        $despachartodo = FALSE;
                                }
                                //////////////////////
                                //bucle PRODUCT_ID END
                                //////////////////////
                        }
                        //////////////////
                        //bucle de COMBOS END
                        //////////////////
                }//foreach BUCLE DE ITEMS END
                //////////////////
                //bucle de ITEMS de la ORDER END
                //////////////////
                if($despachartodo){
                        update_post_meta($order_id,'_dispatchnow','yes');
                        $order->update_status( 'completed' );
                }else{
                        update_post_meta($order_id,'_dispatchnow','no');
                }//if despachar END
//update_post_meta($order_id,'_depu',$depu);

        } // customer_processing_order END

        if ( $email->id == 'customer_completed_order' ) {
                //echo " ENTRO POR COMPLETED ORDER 1... ";
                global $wpdb;
                $order_id=$order->get_id();
                $dispatchnow=get_post_meta($order_id,'_dispatchnow');
$depu=array();
                //////////////////
                // GRAN IF
                //////////////////
$depu['order_id']=$order_id;
$depu['dispatchnow']=$dispatchnow;
                if($dispatchnow[0]=="yes"){
                        $envio=get_post_meta($order_id,'_keys');
                        $generartabla=TRUE;
                        $actualizarstock=TRUE;
                        if (empty($envio)){
$depu['entroporenvio']="yes";
                                $totalitem=0;
                                $items=0;
                                //////////////////
                                //bucle de ITEMS de la ORDER
                                //////////////////
                                foreach( $order->get_items() as $item_id => $item ) {
                                        $items++;
                                        $product_id_1 = $item->get_product_id();
                                        $autodispatch=get_post_meta($product_id_1,'_autodispatch_option');
                                        if($autodispatch[0]<>'yes'){
                                                $despachartodo=FALSE;
                                        }
                                        $quantity = $item->get_quantity();
                                        //las claves son cargadas para el producto raiz, no para las  variaciones
                                        $variation_id = $item->get_variation_id();
$depu['product_id_1']=$product_id_1;
$depu['autodispatch']=$autodispatch;
$depu['quantity']=$quantity;
                                        if($variation_id==0){
                                                $variation_id=$product_id;
                                                $variation=1;
                                        }else{
                                                $variation=obtenervariacion($variation_id);
                                        }
                                        if(escombo($product_id_1)){
                                                $productoscombo=combos($product_id_1);
                                                $l=0;
                                        }else{
                                                unset($productoscombo);
                                                $productoscombo[0]=$product_id_1;
                                        }
$depu['variation_id']=$variation_id;
$depu['variation']=$variation;

                                        //////////////////
                                        //bucle de COMBOS
                                        //////////////////
                                        foreach($productoscombo as $product){
                                                $product_id=$product;
                                                //////////////////
                                                //bucle PRODUCT_ID
                                                //////////////////
                                                $despachados=0;
                                                $cuantas=cuantasllaves($product_id,$variation);//Tengo por ejemplo 3 llaves con mas activaciones que variaciones
                                                $totalitem+=$quantity;
$depu['product_id'][]=$product_id;
$depu['cuantas'][]=$cuantas;
                                                if($cuantas >= $quantity){ /// SI  TENEMOS MAS LLAVES QUE LA CANTIDAD DEL PEDIDO
                                                        //$product_id es el  producto, $variation es 1pc - 5pc, $priority es la prioridad
                                                        $priority=1;//Prioridad por si luego necesitamosbuclear
$depu['priority'][]=$priority;
                                                        $envio1=lasllaves($product_id,$variation,$quantity,$priority);
                                                        $envio[] = $envio1;
                                                        if($quantity>1){
                                                                $despachados+=count($envio1,1);// 1 para recursivo
                                                        }else{
                                                                $despachados+=count($envio1);
                                                        }
$depu['despachados'][]=$despachados;
                                                }//if cuantas > quantity END
                                                if($despachados<>$quantity){
                                                        // POR UN PRODUCTO QUE NO TENGA STOCK, SE CANCELA EL DESPACHO AUTOMATICO
                                                        $generartabla = FALSE;
                                                        $actualizarstock=FALSE;
                                                }
                                                $esd_link1=get_post_meta($product_id,'_download_link');
                                                $esd_link[]=$esd_link1;
                                                //////////////////////
                                                //bucle PRODUCT_ID END
                                                //////////////////////
                                        }
                                        //////////////////
                                        //bucle de COMBOS END
                                        //////////////////
                                }
                                //////////////////
                                //bucle de ITEMS de la ORDER END
                                //////////////////
                        }else{
                                $generartabla=FALSE;// Si se recuperaron los metadatos _key, simplemente mostrarlos
                                $actualizarstock=FALSE;
                                $table_keys=get_post_meta($order_id,'_table_keys');
                                $salida = html_entity_decode($table_keys[0]);
                        }//if empty  envio END
                        if($generartabla){
                                $text_align='center';
                                $salida='<hr><h2>'.__( 'Your Software Activation Keys', 'waolicensemanager' ).'</h2>';
                                $salida.='<table class="td tablekeys" cellspacing="0" cellpadding="6" style="width: 100%; font-family: "Helvetica Neue", Helvetica, Roboto, Arial, sans-serif;" border="1">';
                                $salida.="      <thead>";
                                $salida.="      <tr>";
                                $salida.='              <th class="td" scope="col" style="text-align:'.$text_align.'">'.__( 'Nr.', 'waolicensemanager' ).'</th>';
                                $salida.='              <th class="td" scope="col" style="text-align:'.$text_align.'">'.__( 'Product', 'waolicensemanager' ).'</th>';
                                $salida.='              <th class="td" scope="col" style="text-align:'.$text_align.'">'.__( 'Key', 'waolicensemanager' ).'</th>';
                                $salida.="      </tr>";
                                $salida.="      </thead>";
                                $salida.="      <tbody>";
                                $k=0;
                                $parimpar='par';
                                foreach($envio as $prod){
                                        foreach($prod as $fila){
                                                $parimpar=$parimpar=="par"?"impar":"par";
                                                $salida.="      <tr class='".$parimpar."'>";
                                                $salida.="              <td> ";
                                                $salida.=$fila->nro;
                                                $salida.="              </td>";
                                                $salida.="              <td> ";
                                                $salida.="<p class='pname'>".$fila->productname."</p><p class='pversion' style='font-size:small;'>Version: ".$variation." PC.</p>";
                                                $salida.="              </td>";
                                                $salida.="              <td>";
                                                $salida.=$fila->skey;
                                                $salida.="              </td>";
                                                $salida.="      </tr>";
                                                $actualizarstock&&activaciones($fila->keyid,$variation);
                                        }// foreach END

                                        $options = get_option( '_waolm_options' );
                                        $url1=$options['urlmanuals'];
                                        $esd_link1=$esd_link[$k++][0];

                                        $url_manuals=$url1.$esd_link1;
                                        $salida.= "<tr class='plink'><td colspan=3><p>Download Link:<a href='".$url1."' target='_blank'> ".$fila->productname."</a></td></tr>";
                                }

                                $salida.="</tbody>";
                                $salida.="</table><br><hr>";
                                $actualizarstock&&update_post_meta($order_id,'_keys',$envio);
                                $actualizarstock&&update_post_meta($order_id,'_table_keys',htmlentities($salida));
                        }//if generar tabla END
                        echo $salida;

                }//if dispatchno=yes END
                //////////////////
                // GRAN IF END
                //////////////////
//update_post_meta($order_id,'_depu1',$depu);
        }//$email->id == 'customer_completed_order'  END
}//function END


function lasllaves($producto,$variation,$quantity,$i){
	global $wpdb;
	$margen=5;
	//$q="SELECT P.ID, P.post_title AS key, Q.meta_value AS product, M.meta_value AS productkey, N.meta_value AS activations, R.meta_value AS priority
	$q="SET @numero=0";
	$s = $wpdb->get_var($q);	  
	/*$q="
	SELECT @numero:=@numero+1 AS nro, P.ID AS keyid, P.post_title AS skey, Q.meta_value AS productname, R.meta_value AS priority
		FROM wp_posts P 
		LEFT JOIN wp_postmeta M ON P.ID = M.post_id AND M.meta_key = '_product' 
		LEFT JOIN wp_postmeta N ON P.ID = N.post_id AND N.meta_key = '_activations'
		LEFT JOIN wp_postmeta Q ON P.ID = Q.post_id AND Q.meta_key = '_product_name'
		LEFT JOIN wp_postmeta R ON P.ID = R.post_id AND R.meta_key = '_priority'
		WHERE P.post_type = 'licensemanagerwao'
		  AND P.post_status = 'publish'
		  AND M.meta_value = {$producto}
		  AND N.meta_value >= {$variation}
		  AND R.meta_value >= {$i}
		ORDER BY priority
		LIMIT {$quantity}"; */
	$q="
	SELECT  @numero:=@numero+1 AS nro, P.ID AS keyid, P.post_title AS skey, Q.meta_value AS productname, P.menu_order AS priority
		FROM {$wpdb->prefix}posts P 
		LEFT JOIN {$wpdb->prefix}postmeta M ON P.ID = M.post_id AND M.meta_key = '_product' 
		LEFT JOIN {$wpdb->prefix}postmeta N ON P.ID = N.post_id AND N.meta_key = '_activations'
		LEFT JOIN {$wpdb->prefix}postmeta Q ON P.ID = Q.post_id AND Q.meta_key = '_product_name'
		WHERE P.post_type = 'licensemanagerwao'
		  AND P.post_status = 'publish'
		  AND M.meta_value = {$producto}
		  AND N.meta_value >= {$variation}
		  AND P.menu_order >= {$i}
		ORDER BY priority
		LIMIT {$quantity}";  
	$r = $wpdb->get_results($q);	  
	return $r;
}//function END

function activaciones($post_id,$variation){
	$nuevo = get_post_meta($post_id, '_activations');
	$nuevo = (int)$nuevo[0] - $variation;
	update_post_meta($post_id, '_activations',$nuevo);

	$nuevo = get_post_meta($post_id, '_dispatched');
	$nuevo = (int)$nuevo[0] + $variation;
	update_post_meta($post_id, '_dispatched',$nuevo);
	
}//function actualiza END

function escombo($post_id){
	$combos_option = get_post_meta($post_id,'_combos_option');
	if($combos_option[0]=='One'){
		return FALSE;
	}else{
		return TRUE;
	}
}// function escombo END 

function combos($post_id){
	$combo_products = get_post_meta($post_id,'_combo_products');
	return $combo_products[0];
	//$combo_product[0][''];
}//function combos END

function obtenervariacion($variation_id){
	global $wpdb;
	$q="SELECT menu_order FROM {$wpdb->prefix}posts WHERE ID = {$variation_id}";
	$var=$wpdb->get_var($q);
	return $var[0]; 
} 

function cuantasllaves($product_id,$variation){
	global $wpdb;
	$q="SELECT COUNT(meta_value)
		FROM {$wpdb->prefix}postmeta
		WHERE meta_key = '_activations'
		  AND meta_value > {$variation}
		  AND post_id IN (
			SELECT post_id
				FROM {$wpdb->prefix}postmeta
				WHERE meta_key = '_product'
				  AND meta_value = {$product_id})"; 
	  
	$var=$wpdb->get_var($q);
	return $var[0]>0?$var[0]:1; 
}

function nodespachar(){}


function new_waolicensemanager_column( $columns = array() ) {
    // Add new columns
    $columns['waolicensemanager-status'] = 'Automatic<br>Dispatch';
    return $columns;
}

function waolicensemanager_column_content( $column ) {
    //global $the_order; // you can use the global WP_Order object here
	global $post; // is also available here
 
    if( $column == 'waolicensemanager-status' ) {

		$autodispatch=get_post_meta($post->ID, '_autodispatch_option');

//		$server=get_post_meta($the_order->ID, 'waolicensemanager_server');
	
	if(!empty($autodispatch)&&$autodispatch[0]=="yes"){
			echo "<c style='color:green'>YES</c>";
		}else{
			//echo "no";
		}
        // do stuff, ex: get_post_meta( $post->ID, 'key', true );

    }

}
//add_filter( 'manage_edit-shop_order_columns','new_waolicensemanager_column');
//add_action( 'manage_shop_order_posts_custom_column' , 'waolicensemanager_column_content' );	

add_filter( 'manage_edit-product_columns','new_waolicensemanager_column');
add_action( 'manage_product_posts_custom_column' , 'waolicensemanager_column_content' );	

/*
$options = get_option('_invoices_options');
if($options['waolicensemanagertracking']=="S"){
     add_filter( 'manage_edit-shop_order_columns','new_waolicensemanager_column');
     add_action( 'manage_shop_order_posts_custom_column' , 'waolicensemanager_column_content' );	
}
*/





//////////////////////////////////AQUI TERMINAN LAS FUNCIONES/////////////////////////////////////////////////
